﻿angular.module('VPAdminHTML5Controllers').controller('SelectApps', function ($scope, $location, BannerControlService, Services, DisplaysTree) {
    $scope.lpAppTaskWebReady = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppTaskWebReady");
    $scope.lpAppSelect = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppSelect");
    $scope.lpAppSelectDisplay = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppSelectDisplay");
    $scope.lpAppPublish = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppPublish");
    $scope.lpAppLearn = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppLearn");
    $scope.rpAppSelectType = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("rpAppSelectType");
    $scope.rpAppSelect = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("rpAppSelect");
    $scope.rpAppButtonSelectDisplay = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("rpAppButtonSelectDisplay");

    //Pages: SelectApp 

    $scope.selectedAppName = BannerControlService;
    $scope.selectedAppType = BannerControlService;
    $scope.factoryTalkDirectory = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDServerName;

    $scope.apps = [];
    $scope.appNames = [];
    var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();

    $scope.Init = function () {
        $('body').css("cursor", "wait");
        vpAdminApp.publishLastPageIndex = 0;
        vpAdminApp.republish = true;
        var selectApp = ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass();
        var helpUrl = ViewPoint.Client.VPAdmin.VPAdminUtil.CreateHelpLink(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppLearn_url"));
        document.getElementById('lpAppLearn').href = helpUrl;
        if (!selectApp.isLoaded) {
            selectApp.SelectApp_Loaded($scope);
            $scope.apps = selectApp.apps;
            $scope.factoryTalkDirectory = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDServerName;
            var clientIdentifier = vpAdminApp.GetConnectionHelper().m_ClientIdentifier;
            var platform = selectApp.selectedAppIndex;
            var scope = vpAdminApp._CurrentScope;
            $scope.objAppType = selectApp.apps[platform];
            $scope.selectedAppType.SelectedAppType = $scope.objAppType.appType;
            processGetAppNameService(clientIdentifier, platform, scope, false);
            selectApp.isLoaded = true;
            selectApp.m_ApplicationListModified = true;            
        } else {
            $scope.apps = selectApp.apps;
            $scope.objAppType = selectApp.apps[selectApp.comboSelectedScope];
            $scope.appNames = selectApp.appNames;
            $scope.objAppName = selectApp.appNames[selectApp.comboSelectedApplication];
            $('body').css("cursor", "default");
            document.getElementById('comboSelectScope');
            if (vpAdminApp.UserScope == 0 /* Local */) {
                comboSelectScope.disabled = true;
            }
        }
       
        $('#aLpAppSelect').css("cursor","default");

    }

    $scope.selectAppTypeChanged = function (value, appName) {
        $('body').css("cursor", "wait");
        var selectApp = ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass();
        selectApp.comboSelectScope_SelectionChanged(null);
        var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();
        var clientIdentifier = vpAdminApp.GetConnectionHelper().m_ClientIdentifier;
        var platform = vpAdminApp._CurrentPlatform;
        var scope = vpAdminApp._CurrentScope;
        processGetAppNameService(clientIdentifier, platform, scope, true);
        $scope.selectedAppType.SelectedAppType = value.appType;
        selectApp.comboSelectedScope = document.getElementById('comboSelectScope').selectedIndex;
        selectApp.m_securityGroupsToLoad = true;
    }

    $scope.selectAppNameChanged = function (value) {
        var selectApp = ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass();
        $scope.selectedAppName.SelectedAppName = value;
        ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDApplication = value;
        selectApp.comboSelectedApplication = document.getElementById('comboSelectApplication').selectedIndex;
        selectApp.m_ApplicationListModified = true;
        selectApp.m_securityGroupsToLoad = true;
    }

    var processGetAppNameService = function (clientIdentifier, platform, scope, ignoreManifest) {
        var selectApp = ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass();
        var scopeName = ViewPoint.Client.VPAdmin.WebService.Scope[scope];
        var platformName = ViewPoint.Client.VPAdmin.WebService.TargetPlatform[platform];
        Services.GetApplications(function (data, args) {
            selectApp.LoadApplicationServiceCompleted(data, args);
            $scope.appNames = args.getapplicationNames();
            if(!$scope.appNames[0]){
                //show message error
                //duplicate error message
                //ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage((ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("msgResultUnableToLoadApplication").replace('{0}',$scope.selectedAppType.SelectedAppType)));
            }            
            $scope.objAppName = args.getcurrentApplication() ? args.getcurrentApplication() : $scope.appNames[0];
            $scope.selectedAppName.SelectedAppName = $scope.objAppName;
            ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDApplication = $scope.objAppName;
            selectApp.comboSelectedApplication = getIndex($scope.appNames, $scope.objAppName);
            selectApp.comboSelectedScope = document.getElementById('comboSelectScope').selectedIndex;
            selectApp.m_ApplicationListModified = true;
            $('body').css("cursor", "default");
        }, clientIdentifier, scopeName, platformName, ignoreManifest);
    }

    var getIndex = function (array, name) {
        for (var i = 0; i < array.length; i++) {
            if (array[i] == name)
                return i;
        }
    }

    $scope.onNext = function () {
        if($scope.appNames.length === 0)
            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("msgNoApplicationSelected"));
        else
            $location.path('/selectdisplays');
        var selectApp = ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass();
        selectApp.comboSelectedScope = document.getElementById('comboSelectScope').selectedIndex;
        selectApp.comboSelectedApplication = document.getElementById('comboSelectApplication').selectedIndex;
        selectApp.appNames = $scope.appNames;
    }

    $scope.selectdisplays = function(){
        if($scope.appNames.length === 0)
            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("msgNoApplicationSelected"));
        else
            $location.path('/selectdisplays');
    }
    
    $scope.PgApp2_OnNext = function () {
        $('body').css("cursor", "wait");

        var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();
        var grid = vpAdminApp.Grid;
        var shouldDoGetDisplay = false;
        var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();
        if (grid == null) {
            shouldDoGetDisplay = true;//$location.path('/publish');
        } else {
            var selectedIndex = document.getElementById('comboSelectApplication').selectedIndex;
            var indexContent = document.getElementById('comboSelectApplication')[selectedIndex].textContent;
            var selectedAppName = vpAdminApp.GridName;
            if (selectedIndex == null || selectedAppName == null)
                shouldDoGetDisplay = true;
            else if (selectedAppName != indexContent)
                shouldDoGetDisplay = true; //$location.path('/publish');
        }
        var serviceResultCode = null;
        if (shouldDoGetDisplay) {
             if($scope.appNames.length == 0)
                                ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("msgNoApplicationSelected"));
            else if (ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_ApplicationListModified) {
                ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_ApplicationListModified = false;
                var selectDisplays = ViewPoint.Client.VPAdmin.SelectDisplays.GetSelectDisplayClass();

                var clientIdentifier = vpAdminApp.GetConnectionHelper().m_ClientIdentifier;
                var appToOpen = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDApplication;
                vpAdminApp.GridName = appToOpen;
                var reloadExistingApp = true;

                Services.GetDisplays(function (data, args) {
                    if (args.getResult() != 0 /* Success */) {
                        ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().showerrormessage = false;
                        if (args.geterrorMessage()) {
                            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(args.geterrorMessage());
                        } else {
                            ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.WebService.ConfigServiceStatusCode[args.getResult()]);
                        }
                    } else {
                        serviceResultCode = args.getResult();
                        DisplaysTree.tree = args.getftViewApplication();
                        DisplaysTree.DOM = args.getftViewApplicationDOM();
                        DisplaysTree.forceRepublish = args.getForceRepublish();
                        DisplaysTree.macroList = insertSlash(args);
                        DisplaysTree.PublishTable = BuildPublishTable(DisplaysTree.tree[0], []);
                        if(!vpAdminApp.defaultStartupMacro)
                            vpAdminApp.defaultStartupMacro = "None";
                        vpAdminApp.Grid = DisplaysTree.DOM;
                        grid = DisplaysTree.DOM;
                        if(DisplaysTree.tree[0]){
                            var initialDisplayName = FindInitialDisplay(DisplaysTree.tree[0]);
                            if (initialDisplayName == undefined) {
                                initialDisplayName = GetFirstGraphicDisplay(DisplaysTree.tree[0]);
                            }
                            $(grid.find("Name:Contains(" + initialDisplayName.Name + ")")[0].parentNode).find("IsInitialDisplay")[0].textContent = true;
                            DisplaysTree.treeXML = vpAdminApp.serialize(vpAdminApp.defaultStartupMacro, grid);

                            vpAdminApp.ResetPublish();
                            $location.path('/publishapp');
                        }else{
                             ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().showerrormessage = true;
                             ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("noStartUpDisplay"));
                        }
                    }
                    $('body').css("cursor", "default");

                }, clientIdentifier, appToOpen, reloadExistingApp);
            } else {
                $location.path('/publish');
            }
        } else {            
            if(DisplaysTree.tree[0]){
                var initialDisplayName = FindInitialDisplay(DisplaysTree.tree[0]);
                if (initialDisplayName == undefined) {
                    initialDisplayName = GetFirstGraphicDisplay(DisplaysTree.tree[0]);
                }
                $(grid.find("Name:Contains(" + initialDisplayName.Name + ")")[0].parentNode).find("IsInitialDisplay")[0].textContent = true;
                DisplaysTree.treeXML = vpAdminApp.serialize(vpAdminApp.defaultStartupMacro, grid);
                $location.path('/publishapp');
                ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().ResetPublish();
            }else if(ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().showerrormessage){
                ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("noStartUpDisplay"));
            }
            $('body').css("cursor", "default");
        }
        $('body').css("cursor", "default");
    }
    
    var BuildPublishTable = function (tree, newTable) {
        var counter = 0;
        if (tree.children.length == 0) {
            if (tree.Selected) {
                var publishTxt = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("NewPublish");
                tree.PublishStatus = publishTxt;
                newTable.push(tree);
            }
        }
        else {
            for (var x = 0; x < tree.children.length; x++) {
                BuildPublishTable(tree.children[x], newTable);
            }
            return newTable;
        }
    }

    //This method finds the Graphic Display that is also the Initial Display
    var FindInitialDisplay = function (tree) {

        //This is a leaf
        if (tree.children.length == 0) {
            if (tree.IsInitialDisplay == true)
                return tree;
        }
        else {
            for (var i = 0; i < tree.children.length; i++) {
                return FindInitialDisplay(tree.children[i]);
            }
        }
        return undefined;
    }

    //This method finds the first Graphic Display which is come from the XML
    var GetFirstGraphicDisplay = function (tree) {
        if (tree.children.length == 0) {
            return tree;
        }
        else {
            for (var i = 0; i < tree.children.length; i++) {
                return GetFirstGraphicDisplay(tree.children[i]);
            }
        }
        return undefined;
    }

    var insertSlash = function (args) {
        var obj = new Array();
        obj.push("None");
        for (var i = 0; i < args.getMacroList().length; i++) {
            obj.push('/' + args.getMacroList()[i]);
        }
        return obj;
    }
});


